buildscript {
    repositories {
        jcenter()
    }
}

repositories {
    mavenCentral()
    jcenter()
}

plugins {
    java
    kotlin("jvm") version "1.3.61"
    id("io.gitlab.arturbosch.detekt") version "1.7.0-beta2"
}

group = "it.norangeb.unisannio"

dependencies {
    implementation(kotlin("stdlib-jdk8"))
    implementation("org.jetbrains.kotlinx:kotlinx-coroutines-core:1.3.5")
    implementation("org.apache.activemq:activemq-client:5.15.12")
    implementation("org.glassfish.jersey.containers:jersey-container-grizzly2-http:2.25")
    implementation("org.glassfish.jersey.media:jersey-media-json-jackson:2.25")
    testCompile("junit", "junit", "4.12")
    detektPlugins("io.gitlab.arturbosch.detekt:detekt-formatting:1.7.0-beta2")
}

configure<JavaPluginConvention> {
    sourceCompatibility = JavaVersion.VERSION_1_8
}

tasks {
    compileKotlin {
        kotlinOptions.jvmTarget = "1.8"
    }
    compileTestKotlin {
        kotlinOptions.jvmTarget = "1.8"
    }
}