package drills.drill06.exercise1.point5

import org.apache.activemq.ActiveMQConnectionFactory
import javax.jms.Session
import javax.jms.TextMessage
import javax.jms.TopicConnectionFactory

fun main() {
    val url = "tcp://localhost:61616"
    val factory: TopicConnectionFactory = ActiveMQConnectionFactory(url)

    val connection = factory.createTopicConnection()
    connection.clientID = "client1"
    connection.start()

    val session = connection.createTopicSession(
        false,
        Session.AUTO_ACKNOWLEDGE
    )

    val topic = session.createTopic("hello")
    val subscriber = session.createDurableSubscriber(topic, "s1")

    subscriber.setMessageListener {
        println((it as TextMessage).text)
        session.close()
        connection.close()
    }
}
